<?php
/* 
Plugin Name: Favicon Notifications
Plugin URI: http://www.dilana.in/
Version: 0.3
Author: dilana
Description: Animate your favicon with animated notification badge
*/

if (!defined('ABSPATH')) {
    die("Aren't you supposed to come here via WP-Admin?");
}

global $wpdb;

//Get options from setting page
$fav_options = get_option('fav_option_name');

//Guess the location
define("FAV_PATH", plugin_dir_path(__FILE__));
define("FAV_URL", plugins_url() . '/' . plugin_basename(dirname(__FILE__)));
define("FAV_DOMAIN_NAME", preg_replace('/^www\./', '', $_SERVER['SERVER_NAME']));

define("FAV_TABLE_NAME_VISITS", $wpdb->prefix . "fav_notifications");
define("FAV_TABLE_NAME_READ", $wpdb->prefix . "fav_notifications_posts");
define("FAV_TABLE_NAME_UNREAD", $wpdb->prefix . "fav_notifications_unread");

define("FAV_KEY", uniqid('fav.' . date('U') . '.', true));

if (isset($_COOKIE['wordpress_favicon_key'])) {
    define("FAV_COOKIE_KEY", esc_sql($_COOKIE['wordpress_favicon_key']));
} else {
    define("FAV_COOKIE_KEY", FAV_KEY);
}

define("FAV_DATE", date("Y-m-d H:i:s"));;
define("FAV_ANIMATION", (($fav_options['fav_animation'] && !empty($fav_options['fav_animation'])) ? $fav_options['fav_animation'] : 'fade'));
define("FAV_POSITION", (($fav_options['fav_position'] && !empty($fav_options['fav_position'])) ? $fav_options['fav_position'] : 'down'));
define("FAV_SHAPE", (($fav_options['fav_shape'] && !empty($fav_options['fav_shape'])) ? $fav_options['fav_shape'] : 'circle'));
define("FAV_BG_COLOR", (($fav_options['fav_bg_color'] && !empty($fav_options['fav_bg_color'])) ? $fav_options['fav_bg_color'] : '#dd0000'));
define("FAV_TEXT_COLOR", (($fav_options['fav_text_color'] && !empty($fav_options['fav_text_color'])) ? $fav_options['fav_text_color'] : '#ffffff'));
define("FAV_BADGE_UPDATE", (($fav_options['fav_badge_update'] && !empty($fav_options['fav_badge_update'])) ? $fav_options['fav_badge_update'] : '5'));
define("FAV_DETECT_FROM_DATE", date(
    "Y-m-d H:i:s",
    strtotime(
        (($fav_options['fav_posts_period'] && !empty($fav_options['fav_posts_period'])) ? '-' . $fav_options['fav_posts_period'] : '-30') . " days"
    )
));

define("FAV_DB_VERSION", "0.1");

//Initialization function
function favInstall()
{
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

    $sql_visits = "CREATE TABLE IF NOT EXISTS " . FAV_TABLE_NAME_VISITS . " (
      id int(11) NOT NULL AUTO_INCREMENT,
      unique_key VARCHAR(255) NOT NULL,
      last_visit datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";

    $sql_posts = "CREATE TABLE IF NOT EXISTS " . FAV_TABLE_NAME_READ . " (
      id int(11) NOT NULL AUTO_INCREMENT,
      key_id int(11) NOT NULL,
      post_id int(11) NOT NULL,
      PRIMARY KEY (id)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";

    $sql_unread = "CREATE TABLE IF NOT EXISTS " . FAV_TABLE_NAME_UNREAD . " (
      id int(11) NOT NULL AUTO_INCREMENT,
      key_id int(11) NOT NULL,
      post_id int(11) NOT NULL,
      PRIMARY KEY (id)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";

    dbDelta($sql_visits);
    dbDelta($sql_posts);
    dbDelta($sql_unread);

    add_option("fav_db_version", FAV_DB_VERSION);

    $installed_ver = get_option("fav_db_version");

    if ($installed_ver != FAV_DB_VERSION) {

        /*$sql = "ALTER TABLE " . FAV_TABLE_NAME_VISITS . " DROP COLUMN accessedid ";
        $wpdb->query($sql);

        update_option("fav_db_version", $fav_db_version);*/
    }
}

//WordPress calls this function when the plugin is activated by a WordPress administrator.
register_activation_hook(__FILE__, 'favInstall');

//Update function
function favUpdateDbCheck()
{
    if (get_site_option('fav_db_version') != FAV_DB_VERSION) {
        favInstall();
    }
}

add_action('plugins_loaded', 'favUpdateDbCheck');

include_once('settings.php');
include_once('set.php');
include_once('favicon-track.php');
include_once('ajax-favicon.php');

$favicon_set = new FaviconSet;
$favicon_track = new FaviconTrack;
$ajax_favicon = new AjaxFavicon;

if (is_admin()) {
    $my_settings_page = new FaviconSettings();
}