<?php

class FaviconSet
{

    public function __construct()
    {
        global $ajax_favicon;

        //Load front js
        add_action('wp_enqueue_scripts', array($this, 'wpEnqueueScripts'));

        //Load admin js
        add_action('admin_enqueue_scripts', array($this, 'wpEnqueueAdminScripts'));

        //Load admin css
        add_action('admin_print_styles', array($this, 'wpEnqueueAdminStyles'));
        add_action('wp_enqueue_scripts', array($this, 'wpEnqueueAdminStyles'));

        add_action('wp_ajax_nopriv_ajax_favicon', array(&$ajax_favicon, 'ajaxFavicon'));
        add_action('wp_ajax_ajax_favicon', array(&$ajax_favicon, 'ajaxFavicon'));
    }

    public function wpEnqueueScripts()
    {
        wp_enqueue_script('wp_favico_js', FAV_URL . '/js/favico.js', array('jquery'), '0.3.4', false);
        wp_enqueue_script('wp_favicon_js', FAV_URL . '/js/favicon.js', array('wp_favico_js'), '0.3', false);

        $wp_favicon_vars = array(
            'ajaxurl' => admin_url('admin-ajax.php'),
            'fav_animation' => FAV_ANIMATION,
            'fav_position' => FAV_POSITION,
            'fav_shape' => FAV_SHAPE,
            'fav_bg_color' => FAV_BG_COLOR,
            'fav_text_color' => FAV_TEXT_COLOR,
            'fav_badge_update' => FAV_BADGE_UPDATE
        );
        wp_localize_script('wp_favicon_js', 'wp_favicon', $wp_favicon_vars);
    }

    public function wpEnqueueAdminScripts($hook_suffix)
    {
        if(!strcasecmp($hook_suffix, 'settings_page_favicon_settings')) {
            wp_enqueue_script('wp_colpick_js', FAV_URL . '/js/colpick.js', array('jquery'), '2013', false);
            wp_enqueue_script('wp_admin_favicon_js', FAV_URL . '/js/admin-favico.js', array('wp_colpick_js'), '0.3', false);
        }
    }

    public function wpEnqueueAdminStyles()
    {
        if(is_admin()) {
            wp_enqueue_style('wp_colpick_css', FAV_URL . '/css/colpick.css', false, false, 'all');
        }
    }

}